#include<iostream>
using namespace std;
int main()
{
	int n,i=0,j=0;
	cin>>n;
	int m[n][n];
	int k;
	cin>>k;
	while(i<n)
	{
		j=0;
		while(j<n)
		{
			cin>>m[i][j];
			j++;
		}
		i++;
	}
	i=1;
	j=0;
	int b=0;
	int x=0;
	bool l=true;
	while(i<=k)
	{		
		int xmin=n,xmax=0,ymin=n,ymax=0,a=0,c=0;
		while(j<n)
		{
			while(b<n)
			{
				if(m[j][b]==i)
				{
				if(j>xmax)xmax=j;
				if(b>ymax)ymax=b;
				if(j<xmin)xmin=j;
				if(b<ymin)ymin=b;	
				}
				b++;
			}
			j++;
		}
		a=xmin;c=ymin;
		while(a<=xmax&&l)
		{
			c=ymin;
			while(c<=ymax)
			{ 
				c++;
				if(i!=m[a][c-1])
				l=false;
				
				
			}
			a++;
		}
		if(l)
		{
		x++;
		}
		
		i++;
		l=true;
	}
	cout<<x;
}